﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SQL1 As SQL
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private mdc As myDynamicCalendar
	Dim maxindex As Int = 0
	
	Private btnMenuAgenda As Label
	Dim PopupMenu As RSPopupMenu
	Private lblTopo As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("form_calendario")
	If FirstTime = True Then
		SQL1.Initialize(File.DirInternal, "g2r.db", True)
	End If
	
	PopupMenu.Initialize("PopupMenu", btnMenuAgenda)
	PopupMenu.AddMenuItem(0, 0, "Mês")
	PopupMenu.AddMenuItem(1, 1, "Mês com Eventos")
	PopupMenu.AddMenuItem(2, 2, "Semana")
	PopupMenu.AddMenuItem(3, 3, "Dia")
	PopupMenu.AddMenuItem(4, 4, "Agenda")
	PopupMenu.AddMenuItem(5, 5, "Hoje")
	
	
	'Dim dates() As String = Array As String("10-05-2020","15-05-2020", "16-05-2020", "19-05-2020", "18-05-2020", "18-05-2020", "30-05-2020")
	'Dim starttime() As String = Array As String("08:00", "08:00", "09:00", "10:00", "14:00", "17:00", "15:00")
	'Dim endtime() As String = Array As String("08:30", "08:15", "09:25", "10:45", "14:55", "17:25", "15:15")
	'Dim events() As String = Array As String("Safety Meeting", "Quality Meeting", "Supplier Meeting", "Customer Meeting", "IR Meeting", "My Time", "Finance Meeting")
	
	Dim weekdaynames() As String = Array As String("Seg", "Ter", "Qua", "Qui", "Sex", "Sab", "Dom")
	'Dim weekdaynames() As String = Array As String("星期一", "星期二", "星期四", "星期三", "星期五", "星期六", "星期日")

	
	'Dim holidays() As String = Array As String("14-06-2020", "17-06-2020", "25-12-2020", "26-12-2020", "01-01-2020")

	mdc.showMonthViewWithBelowEvents
	
	
'	For i = 0 To 4
'		mdc.addHolidays(holidays(i))
'	Next
	buscaDadosAgenda

	mdc.HolidayCellBackgroundColor = Colors.LightGray
	mdc.HolidayCellTextColor = Colors.Red
	mdc.CalendarBackgroundColor = Colors.White
	mdc.HeaderBackgroundColor = Colors.White
	mdc.HeaderTextColor = Colors.Magenta
	mdc.NextPreviousIndicatorColor = Colors.Blue
	mdc.WeekDayLayoutBackgroundColor = Colors.Blue
	mdc.WeekDayLayoutTextColor = Colors.White
	mdc.isSaturdayOff(True, Colors.LightGray, Colors.Red)
	mdc.isSundayOff(True, Colors.LightGray, Colors.Red)
	mdc.ExtraDatesOfMonthBackgroundColor = Colors.ARGB(200, 226, 226, 226)
	mdc.ExtraDatesOfMonthTextColor = Colors.White
	mdc.DatesOfMonthBackgroundColor = Colors.Cyan
	mdc.DatesOfMonthTextColor = Colors.ARGB(200, 255, 0, 100)
	
	mdc.WeekDayNames = weekdaynames
	
	mdc.CurrentDateBackgroundColor = Colors.Red
	mdc.CurrentDateTextColor = Colors.White
	
	mdc.EventCellBackgroundColor = Colors.White
	mdc.EventCellTextColor = Colors.Blue
	mdc.BelowMonthEventTextColor = Colors.Black
	mdc.BelowMonthEventDividerColor = Colors.Red
	mdc.HolidayCellClickable = True
	
	mdc.ListOfEvents

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub show(dados As String)
	Log(dados)
	lblTopo.Text = "Agenda de " & geral.nome_tecnico
End Sub


Sub btnMenuAgenda_Click
	PopupMenu.Show
End Sub

Sub PopupMenu_MenuItemClick (ItemId As Int) As Boolean
	If ItemId = 0 Then
		mdc.showMonthView
	Else If ItemId = 1 Then
		mdc.showMonthViewWithBelowEvents
	Else If ItemId = 2 Then
		mdc.showWeekView
	Else If ItemId = 3 Then
		mdc.showDayView
	Else If ItemId = 4 Then
		mdc.showAgendaView
	Else If ItemId = 5 Then
		mdc.showToday
	End If
	Return False
End Sub

Sub buscaDadosAgenda
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT * FROM agenda WHERE status='Pendente' and excluido=0")
		If Cursor.RowCount > 0 Then
			For i = 0 To Cursor.RowCount - 1
				Cursor.Position = i				
				mdc.addEvent(Cursor.GetString("data"), Cursor.GetString("hora_ini"), Cursor.GetString("hora_fim"), Cursor.GetString("nome"))
			Next
			Cursor.Close
			mdc.showMonthViewWithBelowEvents
		End If
		
	Catch
		Log(LastException.Message)
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
End Sub