﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim SQL1 As SQL
	Private phone As Phone
	Dim objWFI As WaitForInternet
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private txtQtdAgenda As Label
	Private txtQtdOs As Label
	Private btnMenu As Label
	Private btnUsuario As Label
	
	Private lblBemVindo As Label
	Dim PopupMenu As RSPopupMenu
	Private lblAviso As Label
	Private pbAviso As ProgressBar
	Dim conectadoWifi As Boolean
	Dim conectado3g As Boolean
	
	Private lblVersao As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("inicio")

	lblBemVindo.Text = "Seja Bem vindo, " & geral.nome_tecnico
	
	PopupMenu.Initialize("PopupMenu", btnMenu)
	PopupMenu.AddMenuItem(0, 0, "Atualizar")
	PopupMenu.AddMenuItem(2, 1, "Configurações")
	PopupMenu.AddMenuItem(1, 3, "Sair")
	
	If FirstTime = True Then
		SQL1.Initialize(File.DirInternal, "g2r.db", True)
	End If
	objWFI.Initialize("objWFI")
	
	lblVersao.Text = "Versão: " & geral.versao & " | Cod.: " & geral.id_tecnico
	'PopupMenu.AddMenuItem(2, 2, "Details")
	'PopupMenu.AddMenuItem(3, 3, "Remove")
	
End Sub

Sub Activity_Resume
	buscaQtdOS
	buscaQtdAgenda
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub show(dados As String)
	
	If dados = 1 Then
		AtualizaTabelaOS
		AtualizaTabelaAgenda
		Atualizaaplicativo
	End If
	
End Sub

Sub pnlAgenda_Click
	CallSubDelayed2(caledario,"show","1")
	
'	If txtQtdAgenda.Text = 0 Then
'		MsgboxAsync("Você não tem nenhuma O.S. pendente","G2R Serviços")
'	Else
'		MsgboxAsync("Em breve","G2R Serviços")
'	End If
	
End Sub

Sub pnlOs_Click
	If txtQtdOs.Text = 0 Then
		MsgboxAsync("Você não tem nenhuma O.S. pendente","G2R Serviços")
	Else
		CallSubDelayed2(telaos,"show","1")
	End If
	
End Sub

Sub btnMenu_Click
	PopupMenu.Show
End Sub

Sub PopupMenu_MenuItemClick (ItemId As Int) As Boolean
	If ItemId = 0 Then
		
		If conectadoWifi = True Or conectado3g = True Then
			AtualizaTabelaOS
			AtualizaTabelaAgenda
		Else
			MsgboxAsync("Sem conexão com a Intenet!","G2R")
		End If
		
		
	Else If ItemId = 1 Then
		'MsgboxAsync("Sair","G2R Serviços")
		fazerLogof
	Else If ItemId = 2 Then
		CallSubDelayed2(telaconfig,"show","")		
	End If
	Return False
End Sub

Sub objWFI_onReceived(Action As String,  WifiAvailable As Boolean, WifiConnected As Boolean, WifiRoaming As Boolean, MobileAvailable As Boolean,MobileConnected As Boolean,MobileRoaming As Boolean, ExtraNetworkInfo As String, HostFound As Boolean)

	'LogColor("Internet:" & WifiConnected,Colors.Red)
	conectadoWifi = WifiConnected
	conectado3g = MobileConnected

End Sub

Sub fazerLogof
	Try
		Msgbox2Async("Deseja fazer fazer logof?", "G2R Serviços", "Sim", "", "Cancelar", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			SQL1.ExecNonQuery("DELETE FROM config")
			
			Dim jo As JavaObject
			jo.InitializeContext
			jo.RunMethod("finishAffinity", Null)
		End If
	Catch
		Log(LastException)
	End Try
	
End Sub

Sub AtualizaTabelaOS
	Try
		DateTime.DateFormat = "yyyy-MM-dd"
		'Dim datahora As String
		'Dim now As Long
		'now = DateTime.Now
		'datahora = DateTime.Date(now) & " " & DateTime.Time(now)
		DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss"
		'Dim dt As Long = DateTime.DateParse(datahora)
		Dim pgValor As Int
		Dim pgTotal As Int
		Dim pgContagem As Int
		pbAviso.Progress = 0
		ProgressDialogShow("Atualizando Contatores")
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"ordem-de-servicos.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&key=" & geral.token_firebase)
		Log(geral.servidor &"ordem-de-servicos.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&key=" & geral.token_firebase)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log(j.GetString)
			'SQL1.ExecNonQuery("DELETE FROM ordem_servico")
			lblAviso.Text = "Atuazando lista de O.S"
			Dim JSON As JSONParser
			JSON.Initialize(J.GetString)
			Dim ListOfPersons As List
			ListOfPersons = JSON.NextArray
			pgTotal = ListOfPersons.Size
			Dim itens As String = ""
			pgValor = 100/pgTotal
			pgContagem = pgValor
			For i = 0 To ListOfPersons.Size - 1
				Dim Map1 As Map
				Map1 = ListOfPersons.Get(i)
				Dim id_os As Int = Map1.Get("id")
				
				Dim comentario As String = FixString(Map1.Get("comentario_tec"))
				Dim os_nome As String = FixString(Map1.Get("os_nome"))
				
				Dim Cursor As Cursor
				Cursor = SQL1.ExecQuery("SELECT id FROM ordem_servico WHERE id = "& id_os &"")
				If Cursor.RowCount > 0 Then
					
					SQL1.ExecNonQuery("UPDATE ordem_servico SET checkin_dt_hra = '"& Map1.Get("checkin_dt_hra") &"', checkout_dt_hra = '"& Map1.Get("checkout_dt_hra") &"', data = '"& Map1.Get("data") &"',obra = '"& Map1.Get("obra") &"',tipo_cli = '"& Map1.Get("tipo_cli") &"',cliente_id = '"& Map1.Get("cliente_id") &"',os_endereco = '"& Map1.Get("os_endereco") &"',os_contato = '"& Map1.Get("os_contato") &"',os_num_motor = '"& Map1.Get("os_num_motor") &"',os_num_gerador = '"& Map1.Get("os_num_gerador") &"',os_hora_func = '"& Map1.Get("os_hora_func") &"',aterramento = '"& Map1.Get("aterramento") &"',test_vazio = '"& Map1.Get("test_vazio") &"',test_vazio_hs = '"& Map1.Get("test_vazio_hs") &"',test_vazio_min = '"& Map1.Get("test_vazio_min") &"',test_carga = '"& Map1.Get("test_carga") &"',test_carga_hs = '"& Map1.Get("test_carga_hs") &"',test_carga_min = '"& Map1.Get("test_carga_min") &"',atend_horario = '"& Map1.Get("atend_horario") &"',atend_classificacao = '"& Map1.Get("atend_classificacao") &"',atend_tipo = '"& Map1.Get("atend_tipo") &"',comentario_tec = '"& comentario &"',os_outros = '"& Map1.Get("os_outros") &"',os_telefone = '"& Map1.Get("os_telefone") &"',os_nome = '"& os_nome &"',os_email = '"& Map1.Get("os_email") &"',data_viagem = '"& Map1.Get("data_viagem") &"',das1 = '"& Map1.Get("das1") &"',das2 = '"& Map1.Get("das2") &"',das3 = '"& Map1.Get("das3") &"',das4 = '"& Map1.Get("das4") &"',as1 = '"& Map1.Get("as1") &"',as2 = '"& Map1.Get("as2") &"',as3 = '"& Map1.Get("as3") &"',as4 = '"& Map1.Get("as4") &"',km_viagem = '"& Map1.Get("km_viagem") &"',tipo_os = '"& Map1.Get("tipo_os") &"',nome_resposavel = '"& Map1.Get("nome_resposavel") &"',data_os = '"& Map1.Get("data_os") &"',responsavel_cpf = '"& Map1.Get("responsavel_cpf") &"',cep = '"& Map1.Get("cep") &"',numero = '"& Map1.Get("numero") &"',bairro = '"& Map1.Get("bairro") &"',complemento = '"& Map1.Get("complemento") &"',cidade = '"& Map1.Get("cidade") &"',estado = '"& Map1.Get("estado") &"',referencia = '"& Map1.Get("referencia") &"',orcamento = '"& Map1.Get("orcamento") &"',prioridade = '"& Map1.Get("prioridade") &"',atualizado = 0,pdf=0 WHERE id= "& id_os &" and atualizado=0")
					gravaEmails(Map1.Get("os_email"),Map1.Get("os_email1"),Map1.Get("os_email2"),id_os,1)
				Else
					
					'Gravação no banco de dados
					'Log("INSERT INTO ordem_servico VALUES("& Map1.Get("id") &",'"& Map1.Get("data") &"','"& Map1.Get("obra") &"','"& Map1.Get("tipo_cli") &"','"& Map1.Get("cliente_id") &"','"& Map1.Get("os_endereco") &"','"& Map1.Get("os_contato") &"','"& Map1.Get("os_num_motor") &"','"& Map1.Get("os_num_gerador") &"','"& Map1.Get("os_hora_func") &"','"& Map1.Get("aterramento") &"','"& Map1.Get("test_vazio") &"','"& Map1.Get("test_vazio_hs") &"','"& Map1.Get("test_vazio_min") &"','"& Map1.Get("test_carga") &"','"& Map1.Get("test_carga_hs") &"','"& Map1.Get("test_carga_min") &"','"& Map1.Get("atend_horario") &"','"& Map1.Get("atend_classificacao") &"','"& Map1.Get("atend_tipo") &"','"& comentario &"','"& Map1.Get("os_outros") &"','"& Map1.Get("os_telefone") &"','"& Map1.Get("os_nome") &"','"& Map1.Get("os_email") &"','"& Map1.Get("data_viagem") &"','"& Map1.Get("das1") &"','"& Map1.Get("das2") &"','"& Map1.Get("das3") &"','"& Map1.Get("das4") &"','"& Map1.Get("as1") &"','"& Map1.Get("as2") &"','"& Map1.Get("as3") &"','"& Map1.Get("as4") &"','"& Map1.Get("km_viagem") &"','"& Map1.Get("tipo_os") &"','"& Map1.Get("nome_resposavel") &"','"& Map1.Get("data_os") &"','"& Map1.Get("responsavel_cpf") &"','"& Map1.Get("cep") &"','"& Map1.Get("numero") &"','"& Map1.Get("bairro") &"','"& Map1.Get("complemento") &"','"& Map1.Get("cidade") &"','"& Map1.Get("estado") &"','"& Map1.Get("referencia") &"','"& Map1.Get("orcamento") &"','"& Map1.Get("prioridade") &"','',0,'','',0,'',0,0)")
					SQL1.ExecNonQuery("INSERT INTO ordem_servico VALUES("& Map1.Get("id") &",'"& Map1.Get("data") &"','"& Map1.Get("obra") &"','"& Map1.Get("tipo_cli") &"','"& Map1.Get("cliente_id") &"','"& Map1.Get("os_endereco") &"','"& Map1.Get("os_contato") &"','"& Map1.Get("os_num_motor") &"','"& Map1.Get("os_num_gerador") &"','"& Map1.Get("os_hora_func") &"','"& Map1.Get("aterramento") &"','"& Map1.Get("test_vazio") &"','"& Map1.Get("test_vazio_hs") &"','"& Map1.Get("test_vazio_min") &"','"& Map1.Get("test_carga") &"','"& Map1.Get("test_carga_hs") &"','"& Map1.Get("test_carga_min") &"','"& Map1.Get("atend_horario") &"','"& Map1.Get("atend_classificacao") &"','"& Map1.Get("atend_tipo") &"','"& comentario &"','"& Map1.Get("os_outros") &"','"& Map1.Get("os_telefone") &"','"& os_nome &"','"& Map1.Get("os_email") &"','"& Map1.Get("data_viagem") &"','"& Map1.Get("das1") &"','"& Map1.Get("das2") &"','"& Map1.Get("das3") &"','"& Map1.Get("das4") &"','"& Map1.Get("as1") &"','"& Map1.Get("as2") &"','"& Map1.Get("as3") &"','"& Map1.Get("as4") &"','"& Map1.Get("km_viagem") &"','"& Map1.Get("tipo_os") &"','"& Map1.Get("nome_resposavel") &"','"& Map1.Get("data_os") &"','"& Map1.Get("responsavel_cpf") &"','"& Map1.Get("cep") &"','"& Map1.Get("numero") &"','"& Map1.Get("bairro") &"','"& Map1.Get("complemento") &"','"& Map1.Get("cidade") &"','"& Map1.Get("estado") &"','"& Map1.Get("referencia") &"','"& Map1.Get("orcamento") &"','"& Map1.Get("prioridade") &"','',0,'','',0,'',0,0)")
					gravaEmails(Map1.Get("os_email"),Map1.Get("os_email1"),Map1.Get("os_email2"),id_os,0)
				End If
				
				atualizaChecklist(id_os)
				
	
				Dim valor As String = "&os_atu[]=" & id_os
				itens = itens & "" & valor
				'convertPdv(id_os)
		
				pgContagem = pgContagem + pgValor
				pbAviso.Progress = pgContagem
				Sleep(0)
			Next
		End If
		j.Release
		If ListOfPersons.Size = 0 Then
			ProgressDialogHide
		End If
		
		lblAviso.Text = "Atualizando Contador"
		buscaQtdOS 'BUSCA A QUANTIDADE DE O.S.
		geral.qtd_os = pgTotal
		pbAviso.Progress = 0
		
		'Log(geral.servidor &"ordem-de-servicos.php?acao=7&id_tec=" & geral.id_tecnico & "&id_os=" & cod_os & "" & itens)
		lblAviso.Text = "Atualizando Banco"
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"ordem-de-servicos.php?acao=8&id_tec=" & geral.id_tecnico & "" & itens)
		Log(geral.servidor &"ordem-de-servicos.php?acao=8&id_tec=" & geral.id_tecnico & "" & itens)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			lblAviso.Text = "Banco Atualizado"
			'convertPdv(cod_os)
			
		End If
		
		
	Catch
		'Log(LastException.Message)
		MsgboxAsync(LastException.Message,"Erro App")
	End Try	
	
	StartService(sincronizar)
	
End Sub

Sub buscaQtdOS
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT * FROM ordem_servico WHERE checkout_dt_hra = ''")
		txtQtdOs.Text = Cursor.RowCount
		Cursor.Close
	Catch
		'Log(LastException.Message)
		MsgboxAsync(LastException.Message,"Erro App")
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
End Sub

Sub buscaQtdAgenda
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT * FROM agenda WHERE status='Pendente' and excluido=0")
		txtQtdAgenda.Text = Cursor.RowCount
		Cursor.Close
	Catch
		Log(LastException.Message)
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
End Sub

'We capture the menu and back keys
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	'Pressing the back key while the slidemenu is open will close it
	If KeyCode = KeyCodes.KEYCODE_BACK Then 
		
		Dim jo As JavaObject
		jo.InitializeContext
		jo.RunMethod("finishAffinity", Null)
		
		Return False
	End If

End Sub


Sub convertPdv(id_os As String)
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(geral.servidor_base &"convert_os_pdf.php?acao=1&id=" & id_os)
	Log(geral.servidor_base &"convert_os_pdf.php?id=" & id_os)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Log("Converteu em pdf")
		Log(j.GetString)
		DownloadAndSaveFile(j.GetString)
	End If
End Sub

Sub DownloadAndSaveFile (id_os As String)
	Dim j As HttpJob
	j.Initialize("", Me)
	Dim Link As String
	Link = geral.servidor_base &"os_pdf/"& id_os &".pdf"
	j.Download(Link)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Dim out As OutputStream = File.OpenOutput(File.DirInternal,id_os &".pdf", False)
		File.Copy2(j.GetInputStream, out)
		out.Close '<------ very important
		Log("Baixou o pdf")
		SQL1.ExecNonQuery("UPDATE ordem_servico SET pdf=1 WHERE id = " & id_os & "")
	End If
	j.Release
	ProgressDialogHide
End Sub

Sub FixString(S As String) As String
   
	' Single Quote replaced with chr(31)
	' Double Quote replaced with chr(30)
   
	S=S.Replace("'",Chr(31))
	S=S.Replace(Chr(34),Chr(30))
   
	Return S
   
End Sub

Sub gravaEmails(email1 As String,email2 As String,email3 As String,cod_os As Int,tipo_gravacao As Int)
	
	Dim qtd As Int = 0
	
	If email1 <> "" Then
		qtd = qtd + 1
	End If
	
	If email2 <> "" Then
		qtd = qtd + 1
	End If
	
	If email3 <> "" Then
		qtd = qtd + 1
	End If
	
	
	If tipo_gravacao = 1 Then
		SQL1.ExecNonQuery("DELETE FROM ordem_servicos_emails WHERE codigo_os = "& cod_os &"")		
	End If
	
	
	For i = 1 To qtd
		
		If i = 1 Then
			SQL1.ExecNonQuery("INSERT INTO ordem_servicos_emails VALUES('"& email1 &"', "& cod_os &")")
		End If
		
		If i = 2 Then
			SQL1.ExecNonQuery("INSERT INTO ordem_servicos_emails VALUES('"& email2 &"', "& cod_os &")")
		End If
		
		If i = 3 Then
			SQL1.ExecNonQuery("INSERT INTO ordem_servicos_emails VALUES('"& email3 &"', "& cod_os &")")
		End If
				
	Next
	
	
End Sub

Sub AtualizaTabelaAgenda
	Try
		Dim pgValor As Int
		Dim pgTotal As Int
		Dim pgContagem As Int
		pbAviso.Progress = 0
		ProgressDialogShow("Atualizando Agenda")
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"agenda.php?acao=1&id_tec=" & geral.id_tecnico & "id_cel="& geral.id_celular)
		Log(geral.servidor &"agenda.php?acao=1&id_tec=" & geral.id_tecnico)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			'Log(j.GetString)
			'SQL1.ExecNonQuery("DELETE FROM ordem_servicos")
			lblAviso.Text = "Atuazando Agenda"
			Dim JSON As JSONParser
			JSON.Initialize(J.GetString)
			Dim ListOfPersons As List
			ListOfPersons = JSON.NextArray
			pgTotal = ListOfPersons.Size
			pgValor = 100/pgTotal
			pgContagem = pgValor
			For i = 0 To ListOfPersons.Size - 1
				Dim Map1 As Map
				Map1 = ListOfPersons.Get(i)
				Dim id_agenda As Int = Map1.Get("id")
				
				Dim obs As String = FixString(Map1.Get("obs"))
				
				Dim Cursor As Cursor
				Cursor = SQL1.ExecQuery("SELECT id FROM agenda WHERE id = "& id_agenda &"")
				If Cursor.RowCount > 0 Then					
					SQL1.ExecNonQuery("UPDATE agenda SET data='"& Map1.Get("data") &"',hora_ini='"& Map1.Get("hora_ini") &"',hora_fim='"& Map1.Get("hora_fim") &"',nome='"& Map1.Get("nome") &"',status='"& Map1.Get("status") &"',tipo_os='"& Map1.Get("tipo_os") &"',obs='"& obs &"',excluido="& Map1.Get("excluido") &" WHERE id= "& id_agenda &" and atualizado=0")
				Else					
					'Gravação no banco de dados
					SQL1.ExecNonQuery("INSERT INTO agenda VALUES("& Map1.Get("id") &",'"& Map1.Get("data") &"','"& Map1.Get("hora_ini") &"','"& Map1.Get("hora_fim") &"','"& Map1.Get("nome") &"','"& Map1.Get("status") &"','"& Map1.Get("tipo_os") &"','"& obs &"',0,"& Map1.Get("excluido") &")")
				End If
	
				pgContagem = pgContagem + pgValor
				pbAviso.Progress = pgContagem
				Sleep(0)
			Next
		End If
		j.Release
		If ListOfPersons.Size = 0 Then
			ProgressDialogHide
		End If
		
		lblAviso.Text = "Agenda Ataulizada"
		buscaQtdAgenda 'BUSCA A QUANTIDADE DE AGENDA
		geral.qtd_agenda = pgTotal
		pbAviso.Progress = 0
				
	Catch
		Log(LastException.Message)
	End Try
		
End Sub

Sub Atualizaaplicativo
	Try
		Dim pgValor As Int
		Dim pgTotal As Int
		Dim pgContagem As Int
		pbAviso.Progress = 0
		ProgressDialogShow("Verficando Atualizações")
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"atualizacao.php?acao=1&id_tec=" & geral.id_tecnico)
		Log(geral.servidor &"atualizacao.php?acao=1&id_tec=" & geral.id_tecnico)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			'Log(j.GetString)
			'SQL1.ExecNonQuery("DELETE FROM ordem_servicos")
			lblAviso.Text = "Atuazando Agenda"
			Dim JSON As JSONParser
			JSON.Initialize(J.GetString)
			Dim ListOfPersons As List
			ListOfPersons = JSON.NextArray
			pgTotal = ListOfPersons.Size
			pgValor = 100/pgTotal
			pgContagem = pgValor
			For i = 0 To ListOfPersons.Size - 1
				Dim Map1 As Map
				Map1 = ListOfPersons.Get(i)
				
				Dim versao_site As Double = Map1.Get("versao")
				Dim nome_versao As String = Map1.Get("nome_versao")
				Dim nome_log As String = Map1.Get("log")
				Dim app_youtube As String = Map1.Get("link_yt")
				
				If versao_site > geral.versao Then
					Msgbox2Async("Exite uma atualização pendente deseja atualizar agora?", "G2R Serviços", "Sim", "", "Não", Null, False)
					Wait For Msgbox_Result (Result As Int)
					If Result = DialogResponse.POSITIVE Then
						'FAZER DOWNLOAD DO NOVO APP
						ProgressDialogShow2("Baixando Aplicativo",False)
						Dim j As HttpJob
						j.Initialize("", Me)
						Dim Link As String
						Link = geral.servidor_base &"apk/"& nome_versao
						Log(Link)
						j.Download(Link)
						Wait For (j) JobDone(j As HttpJob)
						If j.Success Then
							ProgressDialogHide
							Dim out As OutputStream = File.OpenOutput(File.DirInternal,"g2r.apk", False)
							File.Copy2(j.GetInputStream, out)
							out.Close '<------ very important
							SQL1.ExecNonQuery("INSERT INTO atualizacao VALUES('"& versao_site &"','"& nome_log &"','"& app_youtube &"',0,0)")
							Log("Baixou o App")
							instalaApp
							
							
						End If
						j.Release
						ProgressDialogHide
						
					End If
				End If
	
				pgContagem = pgContagem + pgValor
				pbAviso.Progress = pgContagem

			Next
		End If
		j.Release
		If ListOfPersons.Size = 0 Then
			ProgressDialogHide
		End If
		
		lblAviso.Text = "Agenda Ataulizada"
		buscaQtdAgenda 'BUSCA A QUANTIDADE DE AGENDA
		geral.qtd_agenda = pgTotal
		pbAviso.Progress = 0
		
		
	Catch
		Log(LastException.Message)
	End Try
	
	
End Sub

Private Sub CheckInstallationRequirements As ResumableSub
	If File.ExternalWritable = False Then
		MsgboxAsync("Cartão de armazenamento não disponível. Verifique se o seu dispositivo não está conectado no modo de armazenamento USB.", "")
		Return False
	Else If phone.SdkVersion >= 26 And CanRequestPackageInstalls = False Then
		MsgboxAsync("Por favor, permita-me instalar aplicativos.", "")
		Wait For Msgbox_Result(Result As Int)
		Dim in As Intent
		in.Initialize("android.settings.MANAGE_UNKNOWN_APP_SOURCES", "package:" & Application.PackageName)
		StartActivity(in)
		Wait For Activity_Resume '<-- wait for Activity_Resume
		Return CanRequestPackageInstalls
	Else If CheckNonMarketAppsEnabled = False Then
		MsgboxAsync("Ative a instalação de aplicativos não comerciais." & CRLF & "Under Settings - Security - Unknown sources" _
			 & CRLF & "Or Settings - Applications - Unknown sources", "")
		Return False
	Else
		Return True
	End If
End Sub

Private Sub CanRequestPackageInstalls As Boolean
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	Dim PackageManager As JavaObject = ctxt.RunMethod("getPackageManager", Null)
	Return PackageManager.RunMethod("canRequestPackageInstalls", Null)
End Sub

Private Sub CheckNonMarketAppsEnabled As Boolean
	If phone.SdkVersion >= 26 Then Return True
	If phone.SdkVersion < 17 Or phone.SdkVersion >= 21 Then
		Return phone.GetSettings("install_non_market_apps") = "1"
	Else
		Dim context As JavaObject
		context.InitializeContext
		Dim resolver As JavaObject = context.RunMethod("getContentResolver", Null)
		Dim global As JavaObject
		global.InitializeStatic("android.provider.Settings.Global")
		Return global.RunMethod("getString", Array(resolver, "install_non_market_apps")) = "1"
	End If
End Sub

Private Sub SendInstallIntent
	Dim ApkName As String = "g2r.apk"
	File.copy(File.DirInternal, ApkName, Starter.Provider.SharedFolder, ApkName)
	Dim i As Intent
	If phone.SdkVersion >= 24 Then
		i.Initialize("android.intent.action.INSTALL_PACKAGE", Starter.Provider.GetFileUri(ApkName))
		i.Flags = Bit.Or(i.Flags, 1) 'FLAG_GRANT_READ_URI_PERMISSION
	Else
		i.Initialize(i.ACTION_VIEW, "file://" & File.Combine(Starter.Provider.SharedFolder, ApkName))
		i.SetType("application/vnd.android.package-archive")
	End If
	StartActivity(i)
End Sub

Sub instalaApp
	Wait For (CheckInstallationRequirements) Complete (Result As Boolean)
	If Result Then
		SendInstallIntent
	End If
End Sub

Sub atualizaChecklist(id_os As Int)
	Try		
		ProgressDialogShow("Carregado Check-List")
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"checklist.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&id_os="& id_os)
		'Log(geral.servidor &"checklist.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&id_os="& id_os)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log(j.GetString)
			Dim JSON As JSONParser
			JSON.Initialize(J.GetString)
			Dim ListOfPersons As List
			ListOfPersons = JSON.NextArray
			Dim itens As String = ""
			For i = 0 To ListOfPersons.Size - 1
				Dim Map1 As Map
				Map1 = ListOfPersons.Get(i)
				Dim id_check As Int = Map1.Get("id")
				
				Dim descricao As String = FixString(Map1.Get("descricao"))
				
				Dim Cursor As Cursor
				Cursor = SQL1.ExecQuery("SELECT id FROM checklist WHERE id = "& id_check &"")
				If Cursor.RowCount > 0 Then
					'Log("Tipo= " & Map1.Get("tipo"))
					SQL1.ExecNonQuery("UPDATE checklist SET  valor = '"& Map1.Get("valor") &"', descricao = '"& descricao &"', excluido = '"& Map1.Get("excluido") &"', tipo = "& Map1.Get("tipo") &", id_os = "& Map1.Get("os_id") &", ordem = "& Map1.Get("order") &" WHERE id= "& id_check &"")
				Else
					'Gravação no banco de dados
					SQL1.ExecNonQuery("INSERT INTO checklist VALUES("& Map1.Get("id") &","& Map1.Get("os_id") &","& Map1.Get("order") &",'"& descricao &"','"& Map1.Get("excluido") &"','"& Map1.Get("tipo") &"','',0)")
				End If
				
				Dim valor As String = "&check_atu[]=" & id_check
				itens = itens & "" & valor
				Sleep(0)
			Next
		End If
		j.Release

		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"checklist.php?acao=2&id_tec=" & geral.id_tecnico & "" & itens)
		Log(geral.servidor &"checklist.php?acao=2&id_tec=" & geral.id_tecnico & "" & itens)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log("Check Atualizado")
			'convertPdv(cod_os)
			ProgressDialogHide
		End If
		
	Catch
		'Log(LastException.Message)
		MsgboxAsync(LastException.Message,"Erro App")
	End Try
	
	
End Sub

