﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SQL1 As SQL
	Private xui As XUI
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private clformcheck As CustomListView
	Private lblPergunta As Label
	Private opNaoAplica As RadioButton
	Private opNaoOk As RadioButton
	Private opOk As RadioButton
	Private pnlValor As Panel
	Private txtValor As EditText
	
	Dim valor_gravar As String
	Private btnGravar As Label
	Private editou As Int = 0
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("edit_check")
	'ProgressDialogShow2("Carregando Check-list", False)
	'Sleep(0)
	If FirstTime = True Then
		SQL1.Initialize(File.DirInternal, "g2r.db", True)
	End If
	'clformcheck.Add(CreateListItem(clformcheck.AsView.Width, 3670), $"Item #${1}"$)

End Sub

Sub Activity_Resume

End Sub

'We capture the menu and back keys
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	'Pressing the back key while the slidemenu is open will close it
	If KeyCode = KeyCodes.KEYCODE_BACK Or KeyCode = 285 Then
		
		If editou = 1 Then
			EnviarDadosItensChecklist(1)
			Return True
		Else
			Return False
		End If
		'EnviarDadosItensChecklist(1)		
	End If
	
	

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub show(dados As Int)
	Log(dados)
	
	
	CarregaChecklist(dados)
	'ProgressDialogShow("Carregando Check-list.")
End Sub

Private Sub CreateItem(Width As Int, id_check As Int, ordem As Int, Content As String, tipo As Int, valor As String) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	Dim height As Int = 180dip
	If GetDeviceLayoutValues.ApproximateScreenSize < 4.5 Then height = 310dip
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("form_checklist")
	
	lblPergunta.Text = ordem & " - " & Content
	
	pnlValor.Tag = id_check
	opNaoAplica.Tag = id_check
	opNaoOk.Tag = id_check
	opOk.Tag = id_check
	txtValor.Tag = id_check
	
	If tipo = 1 Then
		pnlValor.Visible = False
		opNaoAplica.Visible = True
		opNaoOk.Visible = True
		opOk.Visible = True
		
		If valor = "NÃO APLICA" Then
			opNaoAplica.Checked = True
		Else If valor = "NÃO OK" Then
			opNaoOk.Checked = True
		Else If valor = "OK" Then
			opOk.Checked = True
		End If
		
		
	Else
		
		pnlValor.Visible = True
		opNaoAplica.Visible = False
		opNaoOk.Visible = False
		opOk.Visible = False
		
		If valor <> "" Then
			txtValor.Text = valor
		End If
	End If
	

	'SetColorStateList(lblAction1, xui.Color_LightGray, lblAction1.TextColor)
	'SetColorStateList(lblAction2, xui.Color_LightGray, lblAction2.TextColor)
	'ImageView1.SetBitmap(xui.LoadBitmapResize(File.DirAssets, Image, ImageView1.Width, ImageView1.Height, True))
	Return p
End Sub

Sub CarregaChecklist(id_os As Int)

	Dim id_check As Int
	Dim ordem As Int
	Dim descricao As String
	Dim tipo As Int
	Dim valor As String
	ProgressDialogShow2("Carregando Check-list", False)
	Sleep(0)
	btnGravar.Tag = id_os
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT * FROM checklist WHERE excluido = 0 and id_os = " & id_os & " ORDER BY ordem")
		If Cursor.RowCount > 0 Then
			
			For i = 0 To Cursor.RowCount - 1
				Cursor.Position = i
			
				'Log(Cursor.GetInt("id"))
			
			
				id_check = Cursor.GetInt("id")
				ordem = Cursor.GetInt("ordem")
				descricao = Cursor.GetString("descricao")
				tipo = Cursor.GetInt("tipo")
				valor = Cursor.GetString("valor")
				'Log(tipo)
			
				clformcheck.Add(CreateItem(clformcheck.AsView.Width, id_check,ordem, descricao, tipo,valor), "")
				Sleep(0)
			Next
			Cursor.Close
		Else
			
			ProgressDialogShow2("Buscando dados do Ckeck-List", False)
			Sleep(0)
			Dim j As HttpJob
			j.Initialize("", Me)
			j.Download(geral.servidor_base &"corrige-checklist.php?os=" & id_os)
			Log(geral.servidor_base &"corrige-checklist.php?os=" & id_os)
			Wait For (j) JobDone(j As HttpJob)
			If j.Success Then				
				atualizaChecklist(id_os)
			End If
			
		End If
		
	Catch
		Log(LastException.Message)
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
	editou = 1
	
	ProgressDialogHide
End Sub

Sub txtValor_TextChanged (Old As String, New As String)
	valor_gravar = New
End Sub

Sub opNaoAplica_CheckedChange(Checked As Boolean)
	
	If editou = 1 Then
		
		Dim v As View
		v = Sender
		Dim id_check As String = v.tag
		SQL1.ExecNonQuery("UPDATE checklist SET valor='NÃO APLICA', atualizado=1 WHERE id="& id_check &"")
		editou = 1
		
	End If
	
	
End Sub

Sub opNaoOk_CheckedChange(Checked As Boolean)
	
	If editou = 1 Then
		
		Dim v As View
		v = Sender
		Dim id_check As String = v.tag
		SQL1.ExecNonQuery("UPDATE checklist SET valor='NÃO OK', atualizado=1 WHERE id="& id_check &"")
		editou = 1
		
	End If
		
End Sub

Sub opOk_CheckedChange(Checked As Boolean)
	If editou = 1 Then
		
		Dim v As View
		v = Sender
		Dim id_check As String = v.tag
		SQL1.ExecNonQuery("UPDATE checklist SET valor='OK', atualizado=1 WHERE id="& id_check &"")
		editou = 1
		
	End If
	
End Sub

Sub txtValor_FocusChanged (HasFocus As Boolean)
	Log("Valor =" & txtValor.Text)
	If editou = 1 Then
		
		If HasFocus = False Then
			'Log("EditText1 has lost focus")
			Dim v As View
			v = Sender
			Dim id_check As String = v.tag
			SQL1.ExecNonQuery("UPDATE checklist SET valor='"& valor_gravar &"', atualizado=1 WHERE id="& id_check &"")
			editou = 1
			valor_gravar = ""
		End If
		
	End If
	
	
End Sub

Sub btnGravar_Click
	EnviarDadosItensChecklist(0)
End Sub

Private Sub EnviarDadosItensChecklist(tipo As Int)
	Log("Envia Itens")
	Try
		ProgressDialogShow2("Salvando Check-list", False)
		Dim cod_os As Int = btnGravar.Tag
		
		Dim Cursor As Cursor
		Dim itens As String = ""
		Cursor = SQL1.ExecQuery("SELECT id,valor FROM checklist WHERE atualizado = 1 and id_os = "& cod_os &"")
		If Cursor.RowCount > 0 Then
			For i = 0 To Cursor.RowCount - 1
				Cursor.Position = i
				Dim valor As String = "&id[]=" & Cursor.GetString("id") & "&val[]=" & Cursor.GetString("valor")
				
				itens = itens & "" & valor

			Next
		Else
			Log("Não tem itens")
		End If
		Cursor.Close
		
		'Log(itens)
		'Log(geral.servidor &"ordem-de-servicos.php?acao=7&id_tec=" & geral.id_tecnico & "&id_os=" & cod_os & "" & itens)
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"ordem-de-servicos.php?acao=9&id_tec=" & geral.id_tecnico & "&id_os=" & cod_os & "" & itens)
		Log(geral.servidor &"ordem-de-servicos.php?acao=7&id_tec=" & geral.id_tecnico & "&id_os=" & cod_os & "" & itens)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			SQL1.ExecNonQuery("UPDATE checklist SET atualizado=0 WHERE id_os = " & cod_os & "")
			SQL1.ExecNonQuery("UPDATE ordem_servico SET pdf=0 WHERE id= "& cod_os &"")
			'convertPdv(cod_os)
			Sleep(0)
			editou = 0
			ProgressDialogHide
			If tipo = 1 Then
				Activity.Finish
			End If
			ToastMessageShow("Check-List Salvo",False)
		End If
		
	Catch
		Log(LastException)
	End Try

End Sub

Sub atualizaChecklist(id_os As Int)
	Try
		ProgressDialogShow("Gravando Check-List")
		Sleep(0)
		Dim a As Int = 1
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"checklist.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&id_os="& id_os)
		'Log(geral.servidor &"checklist.php?acao=1&id_tec=" & geral.id_tecnico & "&id_cel="& geral.id_celular & "&versao="& geral.versao & "&id_os="& id_os)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log(j.GetString)
			Dim JSON As JSONParser
			JSON.Initialize(J.GetString)
			Dim ListOfPersons As List
			ListOfPersons = JSON.NextArray
			Dim itens As String = ""
			ProgressDialogShow2("Gravando Check-list",False)
			Sleep(0)
			For i = 0 To ListOfPersons.Size - 1
				Dim Map1 As Map
				Map1 = ListOfPersons.Get(i)
				Dim id_check As Int = Map1.Get("id")
				
				Dim descricao As String = FixString(Map1.Get("descricao"))
				
				Dim Cursor As Cursor
				Cursor = SQL1.ExecQuery("SELECT id FROM checklist WHERE id = "& id_check &"")
				If Cursor.RowCount > 0 Then
					'Log("Tipo= " & Map1.Get("tipo"))
					SQL1.ExecNonQuery("UPDATE checklist SET  valor = '"& Map1.Get("valor") &"', descricao = '"& descricao &"', excluido = '"& Map1.Get("excluido") &"', tipo = "& Map1.Get("tipo") &", id_os = "& Map1.Get("os_id") &", ordem = "& Map1.Get("order") &" WHERE id= "& id_check &"")
				Else
					'Gravação no banco de dados
					SQL1.ExecNonQuery("INSERT INTO checklist VALUES("& Map1.Get("id") &","& Map1.Get("os_id") &","& Map1.Get("order") &",'"& descricao &"','"& Map1.Get("excluido") &"','"& Map1.Get("tipo") &"','',0)")
				End If
				
				Dim valor As String = "&check_atu[]=" & id_check
				itens = itens & "" & valor
				
			Next
		End If
		j.Release

		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(geral.servidor &"checklist.php?acao=2&id_tec=" & geral.id_tecnico & "" & itens)
		Log(geral.servidor &"checklist.php?acao=2&id_tec=" & geral.id_tecnico & "" & itens)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log("Check Atualizado")
			'convertPdv(cod_os)
			CarregaChecklist(id_os)
			ProgressDialogHide
		End If
		
	Catch
		'Log(LastException.Message)
		MsgboxAsync(LastException.Message,"Erro App")
	End Try
	
	
End Sub

Sub FixString(S As String) As String
   
	' Single Quote replaced with chr(31)
	' Double Quote replaced with chr(30)
   
	S=S.Replace("'",Chr(31))
	S=S.Replace(Chr(34),Chr(30))
   
	Return S
   
End Sub