﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
	#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private xui As XUI
	Dim SQL1 As SQL
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private CLV1 As CustomListView
	Private lblTitle As B4XView
	Private ImageView1 As B4XView
	Private lblContent As B4XView
	
	Private btncheckin As Button
	Private btnEditar As Button
	Private btnAssinar As Button
	Private btnVisualizar As Button
	Private btnEmail As Button
	Private btnCheckout As Button
	Private txtCliente As Label
	Private lblData As Label
	Private txtPrioridade As Label
	
	Private checkin As String = ""
	Private checkout As String = ""
	Private txtCheckin As Label
	Private txtAssinatura As Label
	Private pnlMain As Panel
	Private btnFechaAssinatura As Button
	Private SignaturePad As SignPad
	Private btnLimpar As Button
	Private btnSalvar As Button
	Private lbTitulo2 As Label
	Private imgAssinatura As ImageView
	Private btnAtualizar As Label
	Private ProgressBarOS As ProgressBar

	Private pnlMainOs As Panel
	Private Panel1 As Panel
	Private CountDownPane  As Panel
	Dim id_os_assinatura As Int
	Private lbTituloStataus As Label
	
	Private txtEndereco As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("gerenciaros")
	If FirstTime = True Then
		SQL1.Initialize(File.DirInternal, "g2r.db", True)
	End If

End Sub

Sub Activity_Resume
	CLV1.Clear
	CarregaOS
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub show(dados As String)
	
End Sub

Private Sub CreateItem(Width As Int, Title As String, Content As String, data As String, prioridade As String, id As Int,checkin_buton As String,checkout_buton As String,buton_visualiza As Int,os_endereco As String) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	Dim height As Int = 350dip
	If GetDeviceLayoutValues.ApproximateScreenSize < 4.5 Then height = 310dip
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("Card1")
	
	'FORMATA DATA
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim dt As Long = DateTime.DateParse(data)
	DateTime.DateFormat = "dd/MM/yyyy"
	
	
	lblTitle.Text = Title
	txtCliente.Text = Content
	lblData.Text = $"$Date{dt}"$
	txtPrioridade.Text = prioridade
	btncheckin.Tag = id
	btnCheckout.Tag = id
	btnEditar.Tag = id
	btnAssinar.Tag = id
	btnVisualizar.Tag = id
	btnEmail.Tag = id
	Panel1.Tag = id
	txtEndereco.Text = os_endereco
	
	
	
	If checkin_buton <> "" Then
		btncheckin.Enabled = False
		DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss"
		Dim dt As Long = DateTime.DateParse(checkin_buton)
		DateTime.DateFormat = "dd/MM/yyyy HH:mm:ss"
		txtCheckin.Text = $"$Date{dt}"$
		
	End If
	
	If checkout_buton <> "" Then
		btnCheckout.Enabled = False
	End If

	Return p
End Sub

Sub CarregaOS
	
	Dim os_nome As String
	Dim num_os As String
	Dim os_data As String
	Dim os_prioridade As String
	Dim id_os As Int
	Dim checkin_buton As String
	Dim checkout_buton As String
	Dim buton_visualizar As Int
	Dim os_endereco As String
	ProgressDialogShow("Carregando O.S.")
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT id,os_nome,data,prioridade,checkin_dt_hra,checkout_dt_hra,pdf,os_endereco,numero FROM ordem_servico WHERE checkout_dt_hra = ''")
		
		For i = 0 To Cursor.RowCount - 1
			Cursor.Position = i
			
			Log(Cursor.GetInt("id"))
			
			id_os = Cursor.GetInt("id")
			num_os = "Nº: " & Cursor.GetInt("id")
			os_nome = Cursor.GetString("os_nome")
			os_data = Cursor.GetString("data")
			os_prioridade = Cursor.GetString("prioridade")
			checkin_buton = Cursor.GetString("checkin_dt_hra")
			checkout_buton =  Cursor.GetString("checkout_dt_hra")
			buton_visualizar =  Cursor.GetInt("pdf")
			os_endereco =  "End: " & Cursor.GetString("os_endereco") & ", " & Cursor.GetString("numero")
			
			CLV1.Add(CreateItem(CLV1.AsView.Width, num_os, os_nome, os_data,os_prioridade, id_os,checkin_buton,checkout_buton,buton_visualizar,os_endereco), "")
			Sleep(0)
		Next
		Cursor.Close
	Catch
		Log(LastException.Message)
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
	
	ProgressDialogHide
End Sub

Sub btncheckin_Click
	'Dim index As Int = CLV1.GetItemFromView(Sender)
	Dim v As View
	v = Sender
	Dim strTag As String = v.tag
	
	verificaCheckin_checkout(strTag)
	
	If checkin == "" Then
		
		Msgbox2Async("Deseja fazer o Check-in?", "Check-in", "Sim", "", "Cancelar", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			'Log("Check OS = " & strTag)
		
			DateTime.DateFormat = "yyyy-MM-dd"
			Dim now As Long
			now = DateTime.Now
			Dim datahora As String
		
			datahora = DateTime.Date(now) & " " & DateTime.Time(now)
		
			SQL1.ExecNonQuery("UPDATE ordem_servico SET checkin_dt_hra='"& datahora &"', checkin_id_usuario='"& geral.id_tecnico &"', checkin_nome_usuario='"& geral.nomecompleto_tecnico &"', atualizado=1 WHERE id="& strTag &"")
			
			MsgboxAsync("Check-in Realizado com Sucesso!! ","G2R Serviços")
			
			v.Enabled = False
			
			DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss"
			Dim dt As Long = DateTime.DateParse(datahora)
			DateTime.DateFormat = "dd/MM/yyyy HH:mm:ss"
			txtCheckin.Text = $"$Date{dt}"$
			
			StartService(sincronizar)
		End If
	Else
		MsgboxAsync("Check-in já feito: " & CRLF & " "& checkin &" ","G2R Serviços")
	End If
	
End Sub

Sub btnEditar_Click
	'Dim index As Int = CLV1.GetItemFromView(Sender)
	'Log($"Index: ${index}"$)
	Dim v As View
	v = Sender
	Dim strTag As String = v.tag
	verificaCheckin_checkout(strTag)
	If checkin == "" Then
		MsgboxAsync("Necessário fazer o Check-in antes de Editar O.S!","G2R Serviços")
	Else
		CallSubDelayed2(telaEditaos,"show",strTag)
	End If
	
End Sub

Sub btnAssinar_Click
	Dim v As View
	v = Sender
	Dim strTag As String = v.tag
	verificaCheckin_checkout(strTag)
	If checkin == "" Then
		MsgboxAsync("Necessário fazer o Check-in antes de Editar O.S!","G2R Serviços")
	Else
		
		If File.Exists(File.DirInternal, strTag &".png") = True Then
			
			Log("Existe")
			imgAssinatura.Visible = True
			SignaturePad.Visible = False
			Dim bmp As Bitmap = LoadBitmap(File.DirInternal, strTag &".png")
			imgAssinatura.Bitmap = bmp
			btnSalvar.Enabled = False
		Else
			SignaturePad.clear
			SignaturePad.Visible = True
			SignaturePad.Capture(True)
			imgAssinatura.Visible = False
			SignaturePad.Visible = True
			btnSalvar.Enabled = True
			Log("Não Existe")
		End If
		
		If (pnlMain.Visible = True) Then Return

		pnlMain.Left = 0
		pnlMain.Top = 0
		pnlMain.Visible = True
		
		lbTitulo2.Text = "ASSINATURA O.S Nº " & strTag
		btnSalvar.Tag = strTag
		
	End If
	
End Sub

Sub btnVisualizar_Click
	
	Try
		
		Dim v As View
		v = Sender
		Dim strTag As String = v.tag
		
		Dim pdf As Int
		
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT pdf FROM ordem_servico WHERE id = "& strTag &"")
		
		For i = 0 To Cursor.RowCount - 1
			Cursor.Position = i
			
			Log(Cursor.GetInt("pdf"))
			pdf =  Cursor.GetInt("pdf")
								
		Next
		Cursor.Close
		
		If pdf = 1 Then
			Dim FileName As String = strTag & ".pdf"
			File.Copy(File.DirInternal, FileName, Starter.Provider.SharedFolder, FileName)
			Dim in As Intent
			in.Initialize(in.ACTION_VIEW, "")
			Starter.Provider.SetFileUriAsIntentData(in, FileName)
			'Type must be set after calling SetFileUriAsIntentData
			in.SetType("application/pdf")
			StartActivity(in)
		Else
			'MsgboxAsync("Não existe","G2R")
			pnlMainOs.Visible = True
			
			convertPdv(strTag)
						
		End If
		
	Catch
		MsgboxAsync("O.S. ainda não baixada, Tente novamente em alguns Segundos","G2R Serviços")
		SQL1.ExecNonQuery("UPDATE ordem_servico SET atualizado = 1 WHERE codigo_os = "& strTag &"")
		StartService(sincronizar)
	End Try
	
	
End Sub

Sub convertPdv(id_os As String)
	lbTituloStataus.Text = "ATUALIZANDO O.S"
	Dim j As HttpJob
	j.Initialize("", Me)
	If geral.versao_ckecklist = 1 Then
		j.Download(geral.servidor_base &"convert_os_pdf.php?acao=1&id=" & id_os)
	Else
		j.Download(geral.servidor_base &"convert_os_pdf.php?acao=1&id=" & id_os & "&ver=1")
	End If
	
	Log(geral.servidor_base &"convert_os_pdf.php?id=" & id_os)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Log("Converteu em pdf")
		Log(j.GetString)
		DownloadAndSaveFile(j.GetString)
	End If
End Sub

Sub DownloadAndSaveFile (id_os As String)
	lbTituloStataus.Text = "BAIXANDO O.S"
	Dim j As HttpJob
	j.Initialize("", Me)
	Dim Link As String
	Link = geral.servidor_base &"os_pdf/"& id_os &".pdf"
	j.Download(Link)
	Log("Iniciou o download")
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Dim out As OutputStream = File.OpenOutput(File.DirInternal,id_os &".pdf", False)
		File.Copy2(j.GetInputStream, out)
		out.Close '<------ very important
		Log("Baixou o pdf")
		pnlMainOs.Visible = False
		SQL1.ExecNonQuery("UPDATE ordem_servico SET pdf=1 WHERE id = " & id_os & "")
		Dim FileName As String = id_os & ".pdf"
		File.Copy(File.DirInternal, FileName, Starter.Provider.SharedFolder, FileName)
		Dim in As Intent
		in.Initialize(in.ACTION_VIEW, "")
		Starter.Provider.SetFileUriAsIntentData(in, FileName)
		'Type must be set after calling SetFileUriAsIntentData
		in.SetType("application/pdf")
		StartActivity(in)
	End If
	j.Release
	ProgressDialogHide
End Sub

Sub btnEmail_Click
	
	Try
		Dim v As View
		v = Sender
		Dim strTag As String = v.tag
		
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT email FROM ordem_servicos_emails WHERE codigo_os = "& strTag &"")
		If Cursor.RowCount > 0 Then
			
			Dim emails(Cursor.RowCount+2) As String
			For i = 0 To Cursor.RowCount - 1
				Cursor.Position = i
				emails(i) = Cursor.GetString("email")
			Next
			Cursor.Close
			
			Dim a As Int = i
			emails(a) = "Todos"
			a = a + 1
			emails(a) = "Outro"
			
			Dim options As List = emails
			InputListAsync(options, "Selecione o E-mail para O.S", 0, False)
			Wait For InputList_Result (Index As Int)
			If Index <> DialogResponse.CANCEL Then
				'Log("Opção selecionada: " & options.Get(Index))
				 
				If options.Get(Index) = "Outro" Then
					Dim id As InputDialog
					Dim sf As Object = id.ShowAsync("", "Informe o E-mail", "Gravar", "", "Cancel", Null, False)
					Wait For (sf) Dialog_Result(Result As Int)
					If Result = DialogResponse.POSITIVE Then
						Log(id.Input)
						If IsEmail(id.Input) = False Then							
							ToastMessageShow("E-mail Inválido", False)
							Return
						End If
						gravaEmailOS(id.Input, strTag)
						
					End If
				Else If options.Get(Index) = "Todos" Then
					
					Msgbox2Async("Deseja enviar O.S. para todos os e-mails cadastrados?", "Check-in", "Sim", "", "Cancelar", Null, False)
					Wait For Msgbox_Result (Result As Int)
					If Result = DialogResponse.POSITIVE Then
						
						gravaEmailOS("todos", strTag)

					End If
					
					
					'MsgboxAsync("Check-Out Realizado com Sucesso!! ","G2R Serviços")
				Else
					'ENVIA EMAIL PARA O CLIENTE
					Msgbox2Async("Deseja enviar O.S. para o email " & options.Get(Index) &  "?", "Check-in", "Sim", "", "Cancelar", Null, False)
					Wait For Msgbox_Result (Result As Int)
					If Result = DialogResponse.POSITIVE Then
											
						gravaEmailOS(options.Get(Index), strTag)
					End If
					
					'MsgboxAsync("Check-Out Realizado com Sucesso!! ","G2R Serviços")
				End If
				
			End If
			
		
		Else
			
			Dim id As InputDialog
			Dim sf As Object = id.ShowAsync("", "Informe o E-mail", "Enviar", "", "Cancel", Null, False)
			Wait For (sf) Dialog_Result(Result As Int)
			If Result = DialogResponse.POSITIVE Then
				Log(id.Input)
				If IsEmail(id.Input) = False Then
					ToastMessageShow("E-mail Inválido", False)
					Return
				End If
				
				gravaEmailOS(id.Input, strTag)
						
			End If
			
		End If
		
	Catch
		Log(LastException)
	End Try

End Sub

Sub btnCheckout_Click
	Dim index As Int = CLV1.GetItemFromView(Sender)
	'Log($"Index: ${index}"$)
	Dim v As View
	v = Sender
	Dim strTag As String = v.tag
	
	verificaCheckin_checkout(strTag)
	
	If checkin == "" Then
		MsgboxAsync("Necessário fazer o Check-in antes de fazer o Check-out!","G2R Serviços")
	Else
		
		If checkout == "" Then
			
			Msgbox2Async("Deseja fazer o Check-out?", "Check-out", "Sim", "", "Cancelar", Null, False)
			Wait For Msgbox_Result (Result As Int)
			If Result = DialogResponse.POSITIVE Then
				'Log("Check OS = " & strTag)
		
				DateTime.DateFormat = "yyyy-MM-dd"
				Dim now As Long
				now = DateTime.Now
				Dim datahora As String
		
				datahora = DateTime.Date(now) & " " & DateTime.Time(now)
		
				SQL1.ExecNonQuery("UPDATE ordem_servico SET checkout_dt_hra='"& datahora &"', checkout_id_usuario='"& geral.id_tecnico &"', checkout_nome_usuario='"& geral.nomecompleto_tecnico &"', atualizado=1 WHERE id="& strTag &"")
			
				MsgboxAsync("Check-Out Realizado com Sucesso!! ","G2R Serviços")
				
				
				'ENVIA EMAIL PARA O CLIENTE
				enviaEmailOS(strTag)
				
				
				
		
				StartService(sincronizar)
				
				CLV1.RemoveAt(index)
			End If
			
		Else
			MsgboxAsync("Check-out já feito: " & CRLF & " "& checkout &" ","G2R Serviços")
		End If
		
	End If
	
	
	
End Sub

Sub verificaCheckin_checkout(id_os As Int)
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT checkin_dt_hra, checkout_dt_hra FROM ordem_servico WHERE id = "& id_os &"")
		For i = 0 To Cursor.RowCount - 1
			Cursor.Position = i
						
			checkin =  Cursor.GetString("checkin_dt_hra")
			checkout =  Cursor.GetString("checkout_dt_hra")
			
		Next
		Cursor.Close
	Catch
		Log(LastException.Message)
		'gravaLog(LastException.Message,"buscaIdComprador")
	End Try
End Sub

Sub btnFechaAssinatura_Click
	pnlMain.Visible = False
End Sub

Sub btnLimpar_Click
	SignaturePad.clear
	SignaturePad.Visible = True
	SignaturePad.Capture(True)
	imgAssinatura.Visible = False
	SignaturePad.Visible = True
	btnSalvar.Enabled = True
End Sub

Sub btnSalvar_Click
	
	Dim bmp As Bitmap = SignaturePad.TransparentSignatureBitmap
	SignaturePad.saveBitmapToJPG(bmp,File.Combine(File.DirInternal, btnSalvar.Tag & ".png"))
	Log(btnSalvar.Tag & ".png Salva")
	id_os_assinatura = btnSalvar.Tag
	ToastMessageShow("Assinatura Salva com Sucesso!",False)
	btnSalvar.Enabled = False
	uploadiamge(btnSalvar.Tag)
End Sub

Sub uploadiamge(id_os As String)
	
	Try		
		Dim imagens As List
		imagens.Initialize

		Dim fd As MultipartFileData
		fd.Initialize
		fd.KeyName = "arquivo1" 'AQUI É O NOME DO POST DA IMAGEM, O PHP VAI RECEBER COM ESTE NOME
		fd.Dir = File.DirInternal
		fd.FileName = id_os & ".png"
		fd.ContentType = "image/png"
		imagens.Add(fd)
		
		Dim j As HttpJob
		j.Initialize("upload", Me)
		j.PostMultipart(geral.upload_assinatura &"&id_os="& id_os, CreateMap("action": "upload","token": geral.smd5), imagens)
		
		ProgressDialogShow("Salvando Assinatura")
		
	Catch
		Log(LastException)
	End Try
	
End Sub

Sub JobDone (Job As HttpJob)
	If Job.Success = True Then
		Select Job.JobName
	  

			Case "upload"
				Log(Job.GetString)
				If Job.GetString.StartsWith("{") And Job.GetString.Length > 5 Then
					Dim parser As JSONParser
					parser.Initialize(Job.GetString)
					Dim root As Map = parser.NextObject
					Dim success As String = root.Get("success")
					If success Then
						ProgressDialogHide
						'lbresultado.Text = query_return 'COLOCAMOS O LINK DA IMAGEM NA LABEL RESULTADO
						MsgboxAsync("Assinatura salva com sucesso!","")
						
						SQL1.ExecNonQuery("UPDATE ordem_servico SET pdf=0 WHERE id = " & id_os_assinatura & "")
					Else
						ProgressDialogHide
						MsgboxAsync("Ocorreu um erro ao enviar a imagem, tente novamente!","")
						'VERIFIQUE SE VOCÊ DEU PERMISSÃO 777 NA PASTA IMAGENS, ONDE VAI FICAR ARMAZENADA AS IMAGENS
					End If
					Else
					MsgboxAsync("Erro no servidor","")
					ProgressDialogHide
				End If



		End Select
	Else
		ProgressDialogHide
		MsgboxAsync("Erro no servidor","")
	End If
	Job.Release
End Sub

Sub btnAtualizar_Click
	Try
		CLV1.Clear
		CarregaOS
	Catch
		Log(LastException)
	End Try
End Sub

Sub IsEmail(EmailAddress As String) As Boolean
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
	If MatchEmail.Find = True Then
		'Log(MatchEmail.Match)
		Return True
	Else
		'ToastMessageShow("Oops, Por favor verifique novamente o seu endereço de e-mail!", False)
		Return False
	End If
End Sub

Sub gravaEmailOS(email As String, id_os As Int)
	
	Try
		Dim Cursor As Cursor
		Cursor = SQL1.ExecQuery("SELECT * FROM email_envio WHERE codigo_os = "& id_os &"")
		If Cursor.RowCount > 0 Then
			SQL1.ExecNonQuery("UPDATE email_envio SET email='"& email &"' WHERE codigo_os = "& id_os &"")
		Else
			SQL1.ExecNonQuery("INSERT INTO email_envio VALUES('"& email &"',"& id_os &")")
		End If		
		MsgboxAsync("O E-mail será enviodo no momento do Check-out!","G2R Serviços")
	Catch
		Log(LastException.Message)
	End Try	
End Sub

Sub enviaEmailOS(id_os As Int)
	
	Try
		Msgbox2Async("Deseja enviar o e-mail para o cliente?", "Enviar E-mail", "Sim", "", "Cancelar", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			
			Dim Cursor As Cursor
			Dim email As String
			Dim todos As Int = 0
			Cursor = SQL1.ExecQuery("SELECT * FROM email_envio WHERE codigo_os = "& id_os &"")
			For i = 0 To Cursor.RowCount - 1
				Cursor.Position = i
			
				Log(Cursor.GetString("email"))
				email = Cursor.GetString("email")
			
				If email = "todos" Then
					todos = 1
				End If
			Next
			Cursor.Close
			
			Dim j As HttpJob
			j.Initialize("", Me)
			If todos = 0 Then
				j.Download(geral.servidor_base &"acoes/acao-os.php?acao=6&id="& id_os &"&email="& email)
				Log(geral.servidor_base &"acoes/acao-os.php?acao=6&id="& id_os &"&email="& email)
			Else
				j.Download(geral.servidor_base &"acoes/acao-os.php?acao=6&id="& id_os)
				Log(geral.servidor_base &"acoes/acao-os.php?acao=6&id="& id_os)
			End If
			
			ProgressDialogShow("Enviando E-mail")
			Wait For (j) JobDone(j As HttpJob)
			If j.Success Then
				ProgressDialogHide
				MsgboxAsync("E-mail enviado com Sucesso!! ","G2R Serviços")
			End If			
		End If
		
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub Panel1_LongClick
	Dim index As Int = CLV1.GetItemFromView(Sender)
	Dim v As View
	v = Sender
	Dim strTag As String = v.tag
	
	Msgbox2Async("Deseja Remover essa O.S do Aplicativo?", "Excluir", "Sim", "", "Não", Null, False)
	Wait For Msgbox_Result (Result As Int)
	If Result = DialogResponse.POSITIVE Then
		'Log("Check OS = " & strTag)
		
		
		DateTime.DateFormat = "yyyy-MM-dd"
		Dim now As Long
		now = DateTime.Now
		Dim datahora As String
		
		datahora = DateTime.Date(now) & " " & DateTime.Time(now)
		
		SQL1.ExecNonQuery("UPDATE ordem_servico SET checkout_dt_hra='"& datahora &"', checkout_id_usuario='"& geral.id_tecnico &"', checkout_nome_usuario='"& geral.nomecompleto_tecnico &"', atualizado=0 WHERE id="& strTag &"")
		
		CLV1.RemoveAt(index)
	End If
End Sub